#include <stdio.h>
#include <sys/socket.h>

#define panic(n, str) if (n == -1) { perror(str); return 1; }

int main() {
  struct sockaddr name = {0};
  socklen_t namelen = sizeof(name);
  int sockfd = socket(AF_INET, SOCK_STREAM, 0);
  panic(sockfd, "socket");
  panic(getsockname(sockfd, &name, &namelen), "getsockname");
  if (name.sa_family == AF_INET) puts("yay");
  return 0;
}
